zoukankan      html  css  js  c++  java
  • Codeforces Round #417 (Div. 2) C. Sagheer and Nubian Market

    C. Sagheer and Nubian Market
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    On his trip to Luxor and Aswan, Sagheer went to a Nubian market to buy some souvenirs for his friends and relatives. The market has some strange rules. It contains n different items numbered from 1 to n. The i-th item has base cost ai Egyptian pounds. If Sagheer buys k items with indices x1, x2, ..., xk, then the cost of item xj is axj + xj·k for 1 ≤ j ≤ k. In other words, the cost of an item is equal to its base cost in addition to its index multiplied by the factor k.

    Sagheer wants to buy as many souvenirs as possible without paying more than S Egyptian pounds. Note that he cannot buy a souvenir more than once. If there are many ways to maximize the number of souvenirs, he will choose the way that will minimize the total cost. Can you help him with this task?

    Input

    The first line contains two integers n and S (1 ≤ n ≤ 105 and 1 ≤ S ≤ 109) — the number of souvenirs in the market and Sagheer's budget.

    The second line contains n space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 105) — the base costs of the souvenirs.

    Output

    On a single line, print two integers k, T — the maximum number of souvenirs Sagheer can buy and the minimum total cost to buy these k souvenirs.

    Examples
    Input
    3 11
    2 3 5
    Output
    2 11
    Input
    4 100
    1 2 5 6
    Output
    4 54
    Input
    1 7
    7
    Output
    0 0
    Note

    In the first example, he cannot take the three items because they will cost him [5, 9, 14] with total cost 28. If he decides to take only two items, then the costs will be [4, 7, 11]. So he can afford the first and second items.

    In the second example, he can buy all items as they will cost him [5, 10, 17, 22].

    In the third example, there is only one souvenir in the market which will cost him 8 pounds, so he cannot buy it.

    分析:  二分法,不断的缩小可能的区间。

    要注意的是 ,物品序号是最初的序号,与我们选取的顺序无关。

    每次使用二分的时候都需要重新排一次序 找到最优的取法(最优取法随着取的数量会不断变化,所以不能只排一次序)

    复杂度为n(log²n)

    代码如下:

    #include <cstdio>
    #include <algorithm>
    #include <iostream>
    #include <cstring>
    using namespace std;
    typedef long long ll;
    ll sum[100100];
    ll sum2[100100];
    ll sum3[100100];
     ll n,s,l,r,mid,ans,maxx;
    ll check(ll x)
    {
      if(sum2[x]<=s)
        return 1;
      return 0;
    }
    struct node{
        ll id;
        ll pri;
    }a[100100],now[100100];
    int cmp(node x,node y)
    {
        return x.pri<y.pri;
    }
    int main()
    {
        while(scanf("%lld%lld",&n,&s)!=EOF)
        {
            maxx=0;
            memset(sum,0,sizeof(sum));
            memset(sum2,0,sizeof(sum2));
            for(int i=1;i<=n;i++){
                scanf("%lld",&a[i].pri);
                a[i].id=i;
            }
            sort(a+1,a+n+1,cmp);
            for(int i=1;i<=n;i++)
            {
                sum[i]=sum[i-1]+a[i].pri;
            }
            l=0;
            r=n+1;
           while(l+1<r)
           {
             memset(sum2,0,sizeof(sum2));
             mid=(l+r)/2;
              for(int i=1;i<=n;i++)
                now[i].pri=a[i].id*mid+a[i].pri;
                sort(now+1,now+n+1,cmp);
              for(int i=1;i<=n;i++)
              {
               sum2[i]=sum2[i-1]+now[i].pri;
              }
             if(check(mid))
             {
              l=mid;
              ans=sum2[mid];
             }
             else r=mid;
           }
           printf("%lld %lld
    ",l,ans);
        }
        return 0;
    }
    

      

    CF中自己的失误:没有正确理解题意,最后在A被hack之后 乱了节奏,以及自己对复杂度的错误估计放弃了在二分里面写循环。

  • 相关阅读:
    [原创]用“人话”解释不精确线搜索中的Armijo-Goldstein准则及Wolfe-Powell准则
    CV界的明星人物们
    Yoshua Bengio 2016年5月11日在Twitter Boston的演讲PPT
    什么是协变量
    英文写作中的最常见“十大句式”
    英文论文中i.e.,e.g.,etc.,viz.的简要小结
    Tips for writing a paper
    ifram 取父窗体的URL地址
    QML与C++交互:在qml中使用QSqlQueryModel显示数据库数据
    Adapter数据变化改变现有View的实现原理及案例
  • 原文地址:https://www.cnblogs.com/a249189046/p/6931508.html
Copyright © 2011-2022 走看看